/*
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * (the "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://www.mozilla.org/MPL/>.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, WITHOUT
 * WARRANTY OF ANY KIND, either express or implied. See the License for the specific
 * language governing rights and limitations under the License.
 * 
 * The Original Code is the Venice Web Communities System.
 * 
 * The Initial Developer of the Original Code is Eric J. Bowersox <erbo@silcom.com>,
 * for Silverwrist Design Studios.  Portions created by Eric J. Bowersox are
 * Copyright (C) 2002-03 Eric J. Bowersox/Silverwrist Design Studios.  All Rights Reserved.
 * 
 * Contributor(s): 
 */
package com.silverwrist.dynamo.iface;

import java.io.IOException;
import com.silverwrist.dynamo.except.RenderingException;
import com.silverwrist.dynamo.except.ValidationException;

public interface Dialog extends Cloneable, NamedObject
{
  public Object clone();

  public void render(TextRenderControl control) throws IOException, RenderingException;

  public void reset();

  public void load(Request r);

  public Object getValue(String fieldname);

  public boolean containsValue(String fieldname);

  public void setValue(String fieldname, Object value);

  public boolean isEnabled(String fieldname);

  public void setEnabled(String fieldname, boolean flag);

  public void validate(Request r) throws ValidationException;

  public String getTitle();

  public void setTitle(String s);

  public String getSubtitle();

  public void setSubtitle(String s);

  public String getInstructions();

  public void setInstructions(String s);

  public void setErrorMessage(String s);

  public String getClickedButton(Request r);

  public void setRenderParam(String name, String value);

  public void setUpperContentObject(Object o);

  public void setLowerContentObject(Object o);

} // end interface Dialog
